Attribute VB_Name = "modCDKEY"
Public Function KeyDecode(ByRef strCDKey As String, ByRef lngProduct As Long, ByRef lngPublic As Long, ByRef lngPrivate As Long) As Boolean
    Dim A           As Long
    Dim B           As Boolean
    Dim bKey(15)    As Byte
    A = Len(strCDKey)
    If (A < 1) Then Exit Function
    Call CopyMemory(bKey(0), ByVal strCDKey, A)
    If (A = 12) Or (A = 13) Then 'Starcraft
        Call SCKeyDecode(bKey())
        B = True
    ElseIf (A = 16) Then
        B = D2KeyDecode(bKey())
    End If
    If B Then
        Call CopyMemory(lngProduct, bKey(0), 4)
        Call CopyMemory(lngPublic, bKey(4), 4)
        Call CopyMemory(lngPrivate, bKey(8), 4)
    End If
    KeyDecode = B
End Function
Public Function KeyEncode(ByRef lngProduct As Long, ByRef lngPublic As Long, ByRef lngPrivate As Long, ByRef strCDKey As String) As Boolean
    Dim A           As Long
    Dim B           As Boolean
    Dim bKey(15)    As Byte
    Call CopyMemory(bKey(0), lngProduct, 1)
    Call CopyMemory(bKey(1), lngPublic, 3)
    Call CopyMemory(bKey(4), lngPrivate, 4)
    A = Len(strCDKey)
    If (A = 13) Then   'Starcraft
        Call SCKeyEncode(bKey())
        Call CopyMemory(ByVal strCDKey, bKey(0), A)
        KeyEncode = True
    ElseIf (A = 16) Then
        Call D2KeyEncode(bKey())
        Call CopyMemory(ByVal strCDKey, bKey(0), A)
        KeyEncode = True
    End If
End Function



Public Function D2KeyDecode(ByRef bKey() As Byte) As Boolean
    If (D2KeyInit(bKey()) = False) Then Exit Function
    Call D2KeySwap(bKey())
    Call D2KeyXor(bKey())
    Call D2KeyPack(bKey())
    D2KeyDecode = True
End Function
Private Function D2KeyInit(ByRef bKey() As Byte) As Boolean
    Dim i       As Long
    Dim i2      As Long
    Dim A       As Long
    Dim B       As Long
    Dim F       As Long
    Dim R       As Long
    Const K     As String = "246789BCDEFGHJKMNPRTVWXZ"
    B = 3
    R = 1
    For i = 0 To 14 Step 2
        i2 = InStr(1, K, Chr$(bKey(i))) - 1
        If (i2 = -1) Then i2 = 255
        A = i2 * 3
        i2 = InStr(1, K, Chr$(bKey(i + 1))) - 1
        If (i2 = -1) Then i2 = 255
        A = i2 + A * 8
        If (A And 256) = 256 Then
            A = A - 256
            F = F Or R
        End If
        bKey(i) = (A \ 16) And &HF
        bKey(i + 1) = A And &HF
        R = R * 2
    Next i
    For i = 0 To 15
        B = B + bKey(i) Xor (B * 2)
        If bKey(i) > 9 Then bKey(i) = bKey(i) + 7
    Next i
    If Not (B And 255) = F Then Exit Function
    D2KeyInit = True
End Function
Private Sub D2KeySwap(ByRef bKey() As Byte)
    Dim i       As Long
    Dim A       As Byte
    Dim B       As Byte
    For i = 15 To 0 Step -1
        If i > 8 Then
            A = i - 9
        Else
            A = i + 7
        End If
        B = bKey(i)
        bKey(i) = bKey(A)
        bKey(A) = B
    Next i
End Sub
Private Sub D2KeyXor(ByRef bKey() As Byte)
    Dim i       As Long
    Dim A       As Long
    A = &H13AC9741
    For i = 15 To 0 Step -1
        If bKey(i) < 8 Then
            bKey(i) = (A And 7) Xor bKey(i)
            A = (A \ 8)
        ElseIf bKey(i) < &H11 Then
            bKey(i) = (i And 1) Xor bKey(i)
        End If
        If bKey(i) > 9 Then bKey(i) = bKey(i) - 7
    Next i
End Sub
Private Sub D2KeyPack(ByRef bKey() As Byte)
    Dim i       As Long
    Dim A       As Byte
    For i = 0 To 14 Step 2
        bKey(i / 2) = bKey(i + 1) Or (bKey(i) * &H10)
    Next i
    '//Private
    A = bKey(4): bKey(4) = bKey(7): bKey(7) = A
    A = bKey(5): bKey(5) = bKey(6): bKey(6) = A
    '//Public
    A = bKey(1): bKey(1) = bKey(3): bKey(3) = A
    
    '//Private
    Call CopyMemory(bKey(8), bKey(4), 4)
    '//public
    Call CopyMemory(bKey(4), bKey(1), 3)
    bKey(7) = 0
    '//Product
    bKey(1) = 0
    bKey(2) = 0
    bKey(3) = 0
End Sub











Public Sub D2KeyEncode(ByRef bKey() As Byte)
    Call D2KeyUnPack(bKey())
    Call D2KeyUnXor(bKey())
    Call D2KeyUnSwap(bKey())
    Call D2KeyUnInit(bKey())
End Sub
Private Sub D2KeyUnPack(ByRef bKey() As Byte)
    Dim i       As Long
    Dim A       As Byte
    '//Private
    A = bKey(7): bKey(7) = bKey(4): bKey(4) = A
    A = bKey(6): bKey(6) = bKey(5): bKey(5) = A
    '//Public
    A = bKey(3): bKey(3) = bKey(1): bKey(1) = A
    '//Expand from 8 bytes to 16
    For i = 7 To 0 Step -1
        A = bKey(i)
        bKey(i * 2) = (A And &HF0) \ &H10
        bKey((i * 2) + 1) = (A And &HF)
    Next i
End Sub
Private Sub D2KeyUnXor(ByRef bKey() As Byte)
    Dim i       As Long
    Dim A       As Long
    A = &H13AC9741
    For i = 15 To 0 Step -1
        If bKey(i) > 9 Then bKey(i) = bKey(i) + 7
        If bKey(i) < 8 Then
            bKey(i) = (A And 7) Xor bKey(i)
            A = (A \ 8)
        ElseIf bKey(i) < &H11 Then
            bKey(i) = (i And 1) Xor bKey(i)
        End If
    Next i
End Sub
Private Sub D2KeyUnSwap(ByRef bKey() As Byte)
    Dim i       As Long
    Dim A       As Byte
    Dim B       As Byte
    For i = 0 To 15
        If i > 8 Then
            A = i - 9
        Else
            A = i + 7
        End If
        B = bKey(i)
        bKey(i) = bKey(A)
        bKey(A) = B
    Next i
End Sub
Private Sub D2KeyUnInit(ByRef bKey() As Byte)
    Dim i       As Long
    Dim i2      As Long
    Dim A       As Long
    Dim B       As Long
    Dim C       As Long
    Dim F       As Long
    Dim R       As Long
    Const K     As String = "246789BCDEFGHJKMNPRTVWXZ"
    B = 3
    For i = 0 To 15
        If bKey(i) > 9 Then bKey(i) = bKey(i) - 7
        B = B + bKey(i) Xor (B * 2)
    Next i
    B = B And &HFF
    F = &H80
    For i = 14 To 0 Step -2
        A = bKey(i + 1) Or (bKey(i) * &H10)
        If B And F Then A = A + &H100
        C = A Mod &H18
        A = A \ &H18
        bKey(i) = Asc(Mid$(K, A + 1, 1))
        bKey(i + 1) = Asc(Mid$(K, C + 1, 1))
        F = F \ 2
    Next i
End Sub

















Public Sub SCKeyDecode(ByRef bKey() As Byte)
    Dim i       As Long
    Dim i2      As Long
    Dim A       As Long
    Dim B       As Long
    Dim F       As Long
    Dim R       As Long
    '//Swap
    A = 11
    For i = &HC2 To 7 Step -&H11
        B = (i Mod 12)
        F = bKey(A)
        bKey(A) = bKey(B)
        bKey(B) = F
        A = A - 1
    Next i
    '//Hash
    F = &H13AC9741
    For i = 11 To 0 Step -1
        If bKey(i) < &H38 Then
            bKey(i) = ((F And 7) Xor bKey(i))
            F = F \ 8
        ElseIf bKey(i) < &H42 Then
            bKey(i) = ((i And 1) Xor bKey(i))
        End If
        bKey(i) = bKey(i) - &H30
    Next i
    '//Product (1)
    bKey(0) = bKey(1) + bKey(0) * 10
    '//Public (3) '2 to 8
    A = bKey(8)
    For i = 1 To 6
        A = A + bKey(8 - i) * (10 ^ i)
    Next i
    Call CopyMemory(bKey(1), A, 3)
    '//Private (2) '9 to 11
    A = bKey(11) + bKey(10) * 10 + bKey(9) * 100
    Call CopyMemory(bKey(4), A, 4)
    
    '//Private
    Call CopyMemory(bKey(8), bKey(4), 4)
    '//public
    Call CopyMemory(bKey(4), bKey(1), 3)
    bKey(7) = 0
    '//Product
    bKey(1) = 0
    bKey(2) = 0
    bKey(3) = 0
End Sub
Public Sub SCKeyEncode(ByRef bKey() As Byte)
    Dim i       As Long
    Dim i2      As Long
    Dim A       As Long
    Dim B       As Long
    Dim F       As Long
    Dim R       As Long
    Call CopyMemory(A, bKey(4), 4)
    bKey(11) = (A Mod 10)
    bKey(10) = (A Mod 100) \ 10
    bKey(9) = (A Mod 1000) \ 100
    '//Public
    A = 0
    Call CopyMemory(A, bKey(1), 3)
    bKey(8) = (A Mod 10)
    bKey(7) = (A Mod 100) \ 10
    bKey(6) = (A Mod 1000) \ 100
    bKey(5) = (A Mod 10000) \ 1000
    bKey(4) = (A Mod 100000) \ 10000
    bKey(3) = (A Mod 1000000) \ 100000
    bKey(2) = (A Mod 10000000) \ 1000000
    '//Product
    A = bKey(0)
    bKey(1) = (A Mod 10)
    bKey(0) = (A Mod 100) \ 10
    '//Hash
    F = &H13AC9741
    For i = 11 To 0 Step -1
        bKey(i) = bKey(i) + &H30
        If bKey(i) < &H38 Then
            bKey(i) = ((F And 7) Xor bKey(i))
            F = F \ 8
        ElseIf bKey(i) < &H42 Then
            bKey(i) = ((i And 1) Xor bKey(i))
        End If
    Next i
    '//Swap
    A = 0
    For i = 7 To &HC2 Step &H11
        B = (i Mod 12)
        F = bKey(B)
        bKey(B) = bKey(A)
        bKey(A) = F
        A = A + 1
    Next i
    '//Install checksum
    R = 3
    For i = 0 To 11
        R = R + ((bKey(i) - &H30) Xor (R * 2))
    Next i
    bKey(12) = (R Mod 10) + &H30
End Sub
